Package org.apache.storm.security

## Interface INimbusCredentialPlugin

- All Superinterfaces:
    `Shutdownable`
  All Known Implementing Classes:
    `AbstractHadoopNimbusPluginAutoCreds`, `AutoHBaseNimbus`, `AutoHDFSNimbus`, `AutoHiveNimbus`

      public interface INimbusCredentialPlugin
      extends Shutdownable

  Nimbus auto credential plugin that will be called on nimbus host during submit topology option. User can specify a list of implementation using config key nimbus.autocredential.plugins.classes.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `default void` | `populateCredentials​(Map<String,​String> credentials, Map<String,​Object> topologyConf)` | Deprecated.
    `default void` | `populateCredentials​(Map<String,​String> credentials, Map<String,​Object> topoConf, String topologyOwnerPrincipal)` | Method that will be called on nimbus as part of submit topology.
    `void` | `prepare​(Map<String,​Object> conf)` | This method will be called when nimbus initializes.

    - ### Methods inherited from interface org.apache.storm.daemon.Shutdownable

      `shutdown`

- - ### Method Detail

    - #### prepare

          void prepare​(Map<String,​Object> conf)

      This method will be called when nimbus initializes.
      Parameters:
        `conf` - the cluster config

    - #### populateCredentials

          @Deprecated
          default void populateCredentials​(Map<String,​String> credentials,
                                           Map<String,​Object> topologyConf)

      Deprecated.
      Method that will be called on nimbus as part of submit topology. This plugin will be called at least once during the submit Topology action. It will be not be called during activate instead the credentials return by this method will be merged with the other credentials in the topology and stored in zookeeper.
      Parameters:
        `credentials` - credentials map where more credentials will be added.
        `topologyConf` - topology configuration

    - #### populateCredentials

          default void populateCredentials​(Map<String,​String> credentials,
                                           Map<String,​Object> topoConf,
                                           String topologyOwnerPrincipal)

      Method that will be called on nimbus as part of submit topology. This plugin will be called at least once during the submit Topology action. It will be not be called during activate instead the credentials return by this method will be merged with the other credentials in the topology and stored in zookeeper.
      Parameters:
        `credentials` - credentials map where more credentials will be added.
        `topoConf` - topology configuration
        `topologyOwnerPrincipal` - the full principal name of the owner of the topology